## opam 2.0.3

=== debian/changelog ===
opam (2.0.3-1) unstable; urgency=medium

  * New (bugfix) upstream release
  * Restrict dependency on bubblewrap on [linux-any] (Closes: #918345)
  * Update patches

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 01 Feb 2019 12:05:09 +0100

opam (2.0.1-1) unstable; urgency=medium

  * New upstream release
  * Remove patch integrated by upstream:
    - 0001-Configure-user-identity-in-the-test-Git-repository.patch
  * Do not try to build (and ship) dev-manual.pdf as it is not
    provided in upstream's tarball anymore
  * Add patch to fix spelling errors in manpages and binaries
    - 0002-Fix-spelling-error-in-manpage.patch
  * Update copyright file
  * Rename opam-docs package into opam-doc
  * Ship README.md and CHANGES files in opam-installer

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 02 Dec 2018 14:37:00 +0100

=== debian/control ===
Source: opam
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Mehdi Dogguy <mehdi@debian.org>,
 Nicolas Braud-Santoni <nicolas@braud-santoni.eu>
Build-Depends:
 debhelper (>= 11),
 ocaml-nox (>= 4.3.0~),
 ocamlbuild,
 cppo (>= 1.6.0),
 ocaml-findlib (>= 1.2.4),
 dh-ocaml (>= 0.9),
 dune,
 libcudf-ocaml-dev,
 libdose3-ocaml-dev (>= 4.0.1-2~),
 libre-ocaml-dev (>= 1.7.2~),
 libcmdliner-ocaml-dev (>= 1.0.2~),
 libextlib-ocaml-dev,
 libocamlgraph-ocaml-dev (>= 1.8),
 libopam-file-format-ocaml-dev,
 libjsonm-ocaml-dev,
 libopam-file-format-ocaml-dev,
 aspcud,
 rsync,
 unzip,
 openssl,
 git,
 curl
Build-Depends-Indep:
 texlive-latex-base,
 texlive-lang-french,
 texlive-latex-extra,
 texlive-latex-recommended,
 texlive-fonts-recommended,
 pandoc,
 latex-make
Standards-Version: 4.2.1
Rules-Requires-Root: no
Homepage: https://opam.ocaml.org
Vcs-Git: https://salsa.debian.org/ocaml-team/opam.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/opam

Package: opam
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 opam-doc (= ${source:Version}),
 build-essential,
 aspcud | mccs | packup,
 opam-installer,
 bubblewrap [linux-any],
 unzip,
 wget | curl
Recommends:
 ocaml,
 git,
 darcs,
 mercurial,
 m4,
 rsync
Description: package manager for OCaml
 OPAM stands for OCaml PAckage Manager. It aims to suit to a vast number
 of users and use cases, and has unique features:
  * Powerful handling of dependencies: versions constraints, optional
    dependencies, conflicts, etc.
  * Multiple repositories backends: HTTP, rsync, git
  * Ease to create packages and repositories
  * Ability to switch between different compiler versions
 .
 Typically, OPAM will probably make your life easier if you recognize
 yourself in at least one of these profiles:
  * You use multiple versions of the OCaml compiler, or you hack the compiler
    yourself and needs to frequently switch between compiler versions.
  * You use or develop software that needs a specific and/or modified version
    of the OCaml compiler to be installed.
  * You use or develop software that depends on a specific version of an OCaml
    library, or you just want to install a specific version of a package, not
    just the latest one.
  * You want to create your own packages yourself, put them on your own
    repository, with minimal effort.

Package: opam-doc
Architecture: all
Section: doc
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: opam-docs
Replaces: opam-docs
Description: package manager for OCaml (documentation)
 OPAM stands for OCaml PAckage Manager. It aims to suit to a vast number
 of users and use cases, and has unique features:
  * Powerful handling of dependencies: versions constraints, optional
    dependencies, conflicts, etc.
  * Multiple repositories backends: HTTP, rsync, git
  * Ease to create packages and repositories
  * Ability to switch between different compiler versions
 .
 Typically, OPAM will probably make your life easier if you recognize
 yourself in at least one of these profiles:
  * You use multiple versions of the OCaml compiler, or you hack the compiler
    yourself and needs to frequently switch between compiler versions.
  * You use or develop software that needs a specific and/or modified version
    of the OCaml compiler to be installed.
  * You use or develop software that depends on a specific version of an OCaml
    library, or you just want to install a specific version of a package, not
    just the latest one.
  * You want to create your own packages yourself, put them on your own
    repository, with minimal effort.
 .
 This package contains manpages and general documentation about OPAM.

Package: opam-installer
Architecture: any
Breaks: opam (<< 2.0.0-1),
        opam-docs (<< 2.0.0-1)
Replaces: opam (<< 2.0.0-1),
          opam-docs (<< 2.0.0-1)
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: Utility handling (un)installation of Opam .install files
 opam-installer is a small utility, part of Opam, that can interpret
 Opam's .install files and take the appropriate actions.
 .
 OPAM stands for OCaml PAckage Manager. It aims to suit to a vast number
 of users and use cases, and has unique features:
  * Powerful handling of dependencies: versions constraints, optional
    dependencies, conflicts, etc.
  * Multiple repositories backends: HTTP, rsync, git
  * Ease to create packages and repositories
  * Ability to switch between different compiler versions

## opam 2.0.5

=== Makefile ===
ifeq ($(findstring clean,$(MAKECMDGOALS)),)
-include Makefile.config
endif

all: opam opam-installer
	@

ifeq ($(DUNE),)
  DUNE_EXE = src_ext/dune-local/_build_bootstrap/install/default/bin/dune$(EXE)
  ifeq ($(shell command -v cygpath 2>/dev/null),)
    DUNE := $(DUNE_EXE)
  else
    DUNE := $(shell echo "$(DUNE_EXE)" | cygpath -f - -a)
  endif
else
  DUNE_EXE=
endif

OPAMINSTALLER = ./opam-installer$(EXE)

ALWAYS:
	@

DUNE_DEP = ALWAYS $(DUNE_EXE)
JBUILDER_ARGS ?= 
DUNE_ARGS ?= $(JBUILDER_ARGS)
DUNE_PROFILE ?= release

src_ext/dune-local/_build_bootstrap/install/default/bin/dune$(EXE): src_ext/dune-local.stamp
	cd src_ext/dune-local && ocaml bootstrap.ml && ./boot.exe --release

src_ext/dune-local.stamp:
	$(MAKE) -C src_ext dune-local.stamp

dune: $(DUNE_DEP)
	@$(DUNE) build --profile=$(DUNE_PROFILE) $(DUNE_ARGS) @install

opam: $(DUNE_DEP) opam.install
	$(LN_S) -f _build/default/src/client/opamMain.exe $@$(EXE)
ifneq ($(MANIFEST_ARCH),)
	@mkdir -p Opam.Runtime.$(MANIFEST_ARCH)
	@cp -f src/client/Opam.Runtime.$(MANIFEST_ARCH).manifest Opam.Runtime.$(MANIFEST_ARCH)/
	@cd Opam.Runtime.$(MANIFEST_ARCH) && $(LN_S) -f ../src/client/libstdc++-6.dll .
	@cd Opam.Runtime.$(MANIFEST_ARCH) && $(LN_S) -f ../src/client/libwinpthread-1.dll .
	@cd Opam.Runtime.$(MANIFEST_ARCH) && $(LN_S) -f ../src/client/$(RUNTIME_GCC_S).dll .
endif

opam-installer: $(DUNE_DEP)
	$(DUNE) build --profile=$(DUNE_PROFILE) $(DUNE_ARGS) src/tools/opam_installer.exe
	$(LN_S) -f _build/default/src/tools/opam_installer.exe $@$(EXE)

opam-admin.top: $(DUNE_DEP)
	$(DUNE) build --profile=$(DUNE_PROFILE) $(DUNE_ARGS) src/tools/opam_admin_top.bc
	$(LN_S) -f _build/default/src/tools/opam_admin_top.bc $@$(EXE)

lib-ext:
	$(MAKE) -j -C src_ext lib-ext

lib-pkg:
	$(MAKE) -j -C src_ext lib-pkg

download-ext:
	$(MAKE) -C src_ext cache-archives

download-pkg:
	$(MAKE) -C src_ext archives-pkg

clean-ext:
	$(MAKE) -C src_ext distclean

clean:
	$(MAKE) -C doc $@
	rm -f *.install *.env *.err *.info *.out opam$(EXE) opam-admin.top$(EXE) opam-installer$(EXE)
	rm -rf _build Opam.Runtime.*

distclean: clean clean-ext
	rm -rf autom4te.cache bootstrap
	rm -f Makefile.config config.log config.status aclocal.m4
	rm -f src/*.META src/*/.merlin src/stubs/dune src/client/*.dll
	rm -f src/tools/opam-putenv.inc src/client/manifest.inc src/client/opamManifest.inc

OPAMINSTALLER_FLAGS = --prefix "$(DESTDIR)$(prefix)"
OPAMINSTALLER_FLAGS += --mandir "$(DESTDIR)$(mandir)"

# With ocamlfind, prefer to install to the standard directory rather
# than $(prefix) if there are no overrides
ifdef OCAMLFIND
ifndef DESTDIR
ifneq ($(OCAMLFIND),no)
    LIBINSTALL_DIR ?= $(shell PATH="$(PATH)" $(OCAMLFIND) printconf destdir)
endif
endif
endif

ifneq ($(LIBINSTALL_DIR),)
    OPAMINSTALLER_FLAGS += --libdir "$(LIBINSTALL_DIR)"
endif

opam-devel.install: $(DUNE_DEP)
	$(DUNE) build $(DUNE_ARGS) -p opam opam.install
	sed -e "s/bin:/libexec:/" opam.install > $@

opam-%.install: $(DUNE_DEP)
	$(DUNE) build $(DUNE_ARGS) -p opam-$* $@

opam.install: ALWAYS $(DUNE_DEP)
	$(DUNE) build --profile=$(DUNE_PROFILE) $(DUNE_ARGS) opam-installer.install opam.install

opam-actual.install: opam.install man
	@echo 'bin: [' > $@
	@grep -h 'bin/[^/]*' $< >> $@
	@echo ']' >> $@
	@echo 'man: [' >>$@
	@$(patsubst %,echo '  "'%'"' >>$@;,$(wildcard doc/man/*.1))
	@echo ']' >>$@
	@echo 'doc: [' >>$@
	@$(foreach x,$(wildcard doc/man-html/*.html),\
	  echo '  "$x" {"man/$(notdir $x)"}' >>$@;)
	@$(foreach x,$(wildcard doc/pages/*.html),\
	  echo '  "$x" {"$(notdir $x)"}' >>$@;)
	@echo ']' >>$@

OPAMLIBS = core format solver repository state client

opam-%: $(DUNE_DEP)
	$(DUNE) build --profile=$(DUNE_PROFILE) $(DUNE_ARGS) opam-$*.install

opam-lib: $(DUNE_DEP)
	$(DUNE) build --profile=$(DUNE_PROFILE) $(DUNE_ARGS) $(patsubst %,opam-%.install,$(OPAMLIBS))

installlib-%: opam-installer opam-%.install
	$(if $(wildcard src_ext/lib/*),\
	  $(error Installing the opam libraries is incompatible with embedding \
	          the dependencies. Run 'make clean-ext' and try again))
	$(OPAMINSTALLER) $(OPAMINSTALLER_FLAGS) opam-$*.install

uninstalllib-%: opam-installer opam-%.install
	$(OPAMINSTALLER) -u $(OPAMINSTALLER_FLAGS) opam-$*.install

libinstall: $(DUNE_DEP) opam-admin.top $(OPAMLIBS:%=installlib-%)
	@

install: opam-actual.install
	$(OPAMINSTALLER) $(OPAMINSTALLER_FLAGS) $<
	$(OPAMINSTALLER) $(OPAMINSTALLER_FLAGS) opam-installer.install

libuninstall: $(OPAMLIBS:%=uninstalllib-%)
	@

uninstall: opam-actual.install
	$(OPAMINSTALLER) -u $(OPAMINSTALLER_FLAGS) $<

checker:
	$(DUNE) build --profile=$(DUNE_PROFILE) $(DUNE_ARGS) src/tools/opam_check.exe

.PHONY: tests tests-local tests-git
tests: $(DUNE_DEP)
	$(DUNE) build --profile=$(DUNE_PROFILE) $(DUNE_ARGS) opam.install src/tools/opam_check.exe
	$(DUNE) runtest --force --no-buffer --profile=$(DUNE_PROFILE) $(DUNE_ARGS) src/ tests/

# tests-local, tests-git
tests-%:
	$(MAKE) -C tests $*

.PHONY: doc
doc: all
	$(MAKE) -C doc

.PHONY: man man-html
man man-html: opam opam-installer
	$(MAKE) -C doc $@

configure: configure.ac m4/*.m4
	aclocal -I m4
	autoconf

release-%:
	$(MAKE) -C release TAG="$*"

ifeq ($(OCAML_PORT),)
ifneq ($(COMSPEC),)
ifeq ($(shell which gcc 2>/dev/null),)
OCAML_PORT=auto
endif
endif
endif

.PHONY: compiler cold
compiler:
	env MAKE=$(MAKE) ./shell/bootstrap-ocaml.sh $(OCAML_PORT)

cold: compiler
	env PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" ./configure $(CONFIGURE_ARGS)
	env PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" $(MAKE) lib-ext
	env PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" $(MAKE)

cold-%:
	env PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" $(MAKE) $*

.PHONY: run-appveyor-test
run-appveyor-test:
	env PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" ./appveyor_test.sh

=== doc/Makefile ===
-include ../Makefile.config

ifeq ($(DUNE),)
  DUNE_EXE = ../src_ext/dune-local/_build_bootstrap/install/default/bin/dune$(EXE)
  ifeq ($(shell command -v cygpath 2>/dev/null),)
    DUNE := $(DUNE_EXE)
  else
    DUNE := $(shell echo "$(DUNE_EXE)" | cygpath -f - -a)
  endif
else
  DUNE_EXE=
endif

DUNE_PROFILE ?= release
DUNE_ARGS ?= 

ifndef OPAM
  OPAM = $(DUNE) exec --profile=$(DUNE_PROFILE) -- opam
endif

TOPICS  = $(shell $(OPAM) help topics)
TOPICS_ADMIN = cache filter index lint list upgrade

HELPFMT = --help=groff

ifndef OPAM_INSTALLER
  OPAM_INSTALLER = $(DUNE) exec --profile=$(DUNE_PROFILE) -- opam-installer
endif

.PHONY: man html pages
all: man html pages

man:
	rm -rf man
	mkdir -p man
	$(OPAM) $(HELPFMT) > man/opam.1 2> man/err
	for i in $(TOPICS); do\
	  $(OPAM) $$i $(HELPFMT) > man/opam-$$i.1 2>> man/err ; \
	done
	$(OPAM) admin $(HELPFMT) > man/opam-admin.1 2>> man/err
	for i in $(TOPICS_ADMIN); do\
	  $(OPAM) admin $$i $(HELPFMT) > man/opam-admin-$$i.1 2>> man/err ; \
	done
	$(OPAM_INSTALLER) $(HELPFMT) > man/opam-installer.1 2>> man/err
# Dune doesn't (yet) support --no-print-directory
	@sed -f man.sed man/err > man/err2
	@if test -s man/err2 ; then cat man/err2 ; false ; fi

man-html: man
	rm -rf man-html
	mkdir -p $@
	echo '<!DOCTYPE html>' >$@/index.html
	echo '<html><head>' >>$@/index.html
	echo '  <title>Opam man-pages index</title>' >>$@/index.html
	echo '</head><body>' >>$@/index.html
	echo '<h1>Opam $(version) man-pages index</h1>' >>$@/index.html
	echo '<ul>' >>$@/index.html
	for f in man/*; do\
	  man2html -r $$f | sed 1,2d > $@/$$(basename $$f .1).html;\
	  echo "  <li><a href=\"$$(basename $$f .1).html\">$$(basename $$f .1)</a></li>" >>$@/index.html;\
	done
	echo '</ul>' >>$@/index.html
	echo '</body></html>' >>$@/index.html

html:
	rm -rf html
	cd .. && $(DUNE) build --profile=$(DUNE_PROFILE) $(DUNE_ARGS) @doc
	cp -r ../_build/default/_doc/_html html
	sed 's/%{OPAMVERSION}%/'$(version)'/g' index.html > html/index.html
# Not to break older links, add manpages to the `ocamldoc` dir
	mkdir -p html/ocamldoc
	cd html/ocamldoc && for f in ../*/*/index.html; do\
	  ln -sf $$f $$(basename $$(dirname $$f)).html;\
	done

pages/%.html: pages/%.md
	omd $^ -o $@

PAGES=$(wildcard pages/*.md)

pages: $(PAGES:.md=.html)

clean:
	rm -rf dependencies.dot man html/ocamldoc man-html pages/*.html html/index.html

=== release/Makefile ===
TAG = master
VERSION = $(shell git describe $(TAG))
OPAM_VERSION = $(subst -,~,$(VERSION))
GIT_URL = ..

FULL_ARCHIVE_URL = https://github.com/ocaml/opam/releases/download/$(VERSION)/opam-full-$(VERSION).tar.gz

TARGETS = x86_64-linux i686-linux armhf-linux arm64-linux
# todo: x86_64-darwin

OCAMLV = 4.04.2
# currently hardcoded in Dockerfile.in
OCAML_URL = https://caml.inria.fr/pub/distrib/ocaml-$(basename $(OCAMLV))/ocaml-$(OCAMLV).tar.gz

HOST_OS = $(shell uname -s | tr A-Z a-z)
HOST = $(shell uname -m | sed 's/amd64/x86_64/')-$(HOST_OS)

all: $(patsubst %,out/opam-$(VERSION)-%,$(TARGETS))

out/opam-full-$(VERSION).tar.gz:
	mkdir -p out
	cd out && curl -OfL $(FULL_ARCHIVE_URL) || { \
	  git clone $(GIT_URL) -b $(TAG) --depth 1 opam-full-$(VERSION); \
	  sed 's/^AC_INIT(opam,.*)/AC_INIT(opam,$(OPAM_VERSION))/' > \
	    opam-full-$(VERSION)/configure.ac.tmp; \
	  mv opam-full-$(VERSION)/configure.ac.tmp \
	    opam-full-$(VERSION)/configure.ac; \
	  $(MAKE) -C opam-full-$(VERSION) configure download-ext; \
	  tar cz --exclude-vcs opam-full-$(VERSION) -f $(notdir $@); \
	  rm -rf opam-full-$(VERSION); \
	}

build/Dockerfile.x86_64-linux: Dockerfile.in
	mkdir -p build && sed 's/%TARGET_TAG%/amd64-jessie/g' $^ | sed 's/%CONF%//g' >$@
build/Dockerfile.i686-linux: Dockerfile.in
	mkdir -p build && sed 's/%TARGET_TAG%/i386-jessie/g' $^ | sed 's/%CONF%/-host i686-linux/g' >$@
build/Dockerfile.armhf-linux: Dockerfile.in
	mkdir -p build && sed 's/%TARGET_TAG%/armhf-jessie/g' $^ | sed 's/%CONF%//g' >$@
build/Dockerfile.arm64-linux: Dockerfile.in
	mkdir -p build && sed 's/%TARGET_TAG%/arm64-jessie/g' $^ | sed 's/%CONF%//g' >$@


build/%.image: build/Dockerfile.%
	docker build -t opam-build-$* -f $^ build
	touch $@

# Actually, this is for debian 8 jessie, and varies wildly
CLINKING_linux = \
-Wl,-Bstatic \
-lunix -lbigarray -lmccs_stubs -lmccs_glpk_stubs \
-lstdc++ \
-Wl,-Bdynamic \
-static-libgcc

CLINKING_darwin = \
-lunix -lbigarray -lmccs_stubs -lmccs_glpk_stubs \
-lstdc++

CLINKING_openbsd = $(CLINKING_darwin)

LINKING = (-noautolink $(patsubst %,-cclib %,$(CLINKING_$(1))))

EXPORTS_openbsd = \
CPATH=/usr/local/include: \
LIBRARY_PATH=/usr/local/lib: \


%: opam-$(VERSION)-%

opam-$(VERSION)-%: out/opam-$(VERSION)-%
	ln -sf $^ $@

# host: opam-$(VERSION)-$(HOST)

# Build for the local host. Containerised builds, below, are preferred, but not always available
build/$(HOST).env:
	mkdir -p build/$(HOST)
	cd build/$(HOST) && curl -OL $(OCAML_URL)
	cd build/$(HOST) && tar xzf ocaml-$(OCAMLV).tar.gz
	cd build/$(HOST)/ocaml-$(OCAMLV) && \
	  ./configure -prefix $(shell pwd)/build/$(HOST) && \
	  $(MAKE) world opt.opt && \
	  $(MAKE) install
	rm -rf build/$(HOST)/ocaml-$(OCAMLV) build/$(HOST)/ocaml-$(OCAMLV).tar.gz
	touch $@

# Actually builds out/opam-$(VERSION)-$(HOST), but we don't want to override the
# rule that goes through a container
host: out/opam-full-$(VERSION).tar.gz build/$(HOST).env
	rm -rf build/opam-full-$(VERSION)
	cd build && tar xzf ../$<
	( export \
	    PATH=$(shell pwd)/build/$(HOST)/bin:$$PATH \
	    MAKE=$(MAKE) \
	    $(EXPORTS_$(HOST_OS)); \
	  cd build/opam-full-$(VERSION) && \
	  ./configure && \
	  echo "$(call LINKING,$(HOST_OS))" >src/client/linking.sexp && \
	  $(MAKE) lib-ext DUNE_ARGS="--root=`pwd`"; \
	  $(MAKE) opam DUNE_ARGS="--root=`pwd`"; \
	)
	cp build/opam-full-$(VERSION)/opam out/opam-$(VERSION)-$(HOST)
	strip out/opam-$(VERSION)-$(HOST)
	rm -rf build/opam-full-$(VERSION)

# Containerised builds
out/opam-$(VERSION)-%-linux: build/%-linux.image out/opam-full-$(VERSION).tar.gz
	docker run --rm -v `pwd`/out:/src \
	  -e "VERSION=$(VERSION)" \
	  -e "TARGET=$*-linux" \
	  -e "LINKING=$(call LINKING,$(HOST_OS))" \
	  opam-build-$*-linux

clean:
	rm -rf build

distclean: clean
	rm -rf out

REMOTE_DIR = /tmp/opam-release
REMOTE_MAKE = make
remote: out/opam-full-$(VERSION).tar.gz
	ssh "$(REMOTE)" "mkdir -p $(REMOTE_DIR)/out"
	scp Makefile "$(REMOTE):$(REMOTE_DIR)/"
	scp "$^" "$(REMOTE):$(REMOTE_DIR)/$^"
	ssh "$(REMOTE)" 'sh -c "cd $(REMOTE_DIR) && ulimit -s 8192 && $(REMOTE_MAKE) host TAG=$(TAG) VERSION=$(VERSION) OCAMLV=$(OCAMLV)"'
	scp "$(REMOTE):$(REMOTE_DIR)/out/opam-$(VERSION)*" out/

=== debian/changelog ===
opam (2.0.5-1ubuntu1) focal; urgency=medium

  * Fix FTBFS with Dune 2.0. Patch adapted from upstream.

 -- William Grant <wgrant@ubuntu.com>  Mon, 13 Apr 2020 12:21:32 +1000

opam (2.0.5-1) unstable; urgency=medium

  * New upstream version 2.0.5
    + Forward-compatibility improvements (OCaml 4.08, Dune 1.7 and later, ...)
    + Numerous bugfixes
    + Patch typos
    + Fixup opam's version number in debian/rules
      Upstream's tarball has the wrong version number set.

  * Build OPAM with its internal solver; add dependency on ocaml-mccs.
  * Remove dependency on external CUDF solvers. (Closes: #908203, #907636)
  * Add basic autopkgtest (opam init && opam install some packages)
    This is sufficient to catch #907636

  * opam: Replace {pre,post}* scripts with a declarative maintscript
  * Switch to debhelper 12, remove the old-style debian/compat.
    This is because dh's compatibility level 12 hard-errors on maintscript issues.
    dh 12 is available in stretch-backports, buster, and later.

  * debian/control: Remove unnecessary dependencies
  * Update authorship information (dates, email, ...)
  * Declare compliance with policy 4.4.0
  * Override spurious Lintian warnings

 -- Nicolas Braud-Santoni <nicoo@debian.org>  Sat, 17 Aug 2019 17:37:02 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: opam
 Section: ocaml
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
  Mehdi Dogguy <mehdi@debian.org>,
- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>
+ Nicolas Braud-Santoni <nicoo@debian.org>
 Build-Depends:
- debhelper (>= 11),
+ debhelper-compat (= 12),
  ocaml-nox (>= 4.3.0~),
  ocamlbuild,
  cppo (>= 1.6.0),
@@ -18,15 +19,9 @@
  libre-ocaml-dev (>= 1.7.2~),
  libcmdliner-ocaml-dev (>= 1.0.2~),
  libextlib-ocaml-dev,
+ libmccs-ocaml-dev,
  libocamlgraph-ocaml-dev (>= 1.8),
  libopam-file-format-ocaml-dev,
- libjsonm-ocaml-dev,
- libopam-file-format-ocaml-dev,
- aspcud,
- rsync,
- unzip,
- openssl,
- git,
  curl
 Build-Depends-Indep:
  texlive-latex-base,
@@ -36,11 +31,12 @@
  texlive-fonts-recommended,
  pandoc,
  latex-make
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Rules-Requires-Root: no
 Homepage: https://opam.ocaml.org
 Vcs-Git: https://salsa.debian.org/ocaml-team/opam.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/opam
+Testsuite: autopkgtest
 
 Package: opam
 Architecture: any
@@ -50,7 +46,6 @@
  ${misc:Depends},
  opam-doc (= ${source:Version}),
  build-essential,
- aspcud | mccs | packup,
  opam-installer,
  bubblewrap [linux-any],
  unzip,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1
export DH_OPTIONS=-v
export JBUILDER_ARGS=--verbose

DESTDIR=$(CURDIR)/debian/tmp
include /usr/share/ocaml/ocamlvars.mk
OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure: .configure_stamp

.configure_stamp:
	# Upstream shipped a release tarball with the wrong version
	sed -i 's/2\.0\.4/2.0.5/g' configure
	./configure --prefix=/usr --libdir=$(OCAML_STDLIB_DIR) \
		--enable-certificate-check
	touch .configure_stamp

.PHONY: override_dh_auto_build
override_dh_auto_build:
# do nothing

build-arch: .configure_stamp
	$(MAKE)

build-indep: .configure_stamp
	$(MAKE) man

.PHONY: override_dh_auto_test
override_dh_auto_test:
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	dh_auto_test
endif

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	$(MAKE) clean || true

.PHONY: override_dh_installdocs
override_dh_installdocs:
	dh_installdocs -p opam --link-doc=opam-installer
	dh_installdocs --remaining-packages

.PHONY: override_dh_missing
override_dh_missing:
	dh_missing --fail-missing

=== debian/tests/control ===
Tests: 4.08.1
Depends: @
Restrictions: isolation-container
# Container (or greater) isolation seems required for bwrap to work correctly

## opam 2.0.8

=== debian/changelog ===
opam (2.0.8-1) unstable; urgency=medium

  * New (bugfix) upstream release
  * Add patch 0004-Use-HOME-env-variable-instead-of.patch to use env
    variable HOME instead of relying on ~
  * Add patch 0005-Port-to-Dose3-6.0.1.patch so that opam builds with
    Dose3 6.0.1
  * Bump build dependency on libdose3-ocaml-dev to >= 6.0.1~

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 28 Feb 2021 20:00:48 +0100

opam (2.0.7-3) unstable; urgency=medium

  [ Helmut Grohne ]
  * Mark opam-doc Multi-Arch: foreign (Closes: #940323)

  [ Mehdi Dogguy ]
  * Set a fixed and fake HOME directory so that it doesn't change
    in generated documentation

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 01 Feb 2021 22:09:37 +0100

opam (2.0.7-2) unstable; urgency=medium

  * Move documentation files back in opam-installer and update needed
    Breaks/Replaces in opam-installer's stanza (Closes: #980309)

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 17 Jan 2021 21:21:31 +0100

opam (2.0.7-1) unstable; urgency=medium

  * New minor upstream release (Closes: #975853)
  * Bump Build-Depend on libopam-file-format-ocaml-dev to (>= 2.1.2-2~)
  * Update opam{,-installer}.install files following changes made upstream

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 17 Jan 2021 11:00:31 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: opam
 Section: ocaml
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
  Mehdi Dogguy <mehdi@debian.org>,
  Nicolas Braud-Santoni <nicoo@debian.org>
@@ -15,13 +14,13 @@
  dh-ocaml (>= 0.9),
  dune,
  libcudf-ocaml-dev,
- libdose3-ocaml-dev (>= 4.0.1-2~),
+ libdose3-ocaml-dev (>= 6.0.1~),
  libre-ocaml-dev (>= 1.7.2~),
  libcmdliner-ocaml-dev (>= 1.0.2~),
  libextlib-ocaml-dev,
  libmccs-ocaml-dev,
  libocamlgraph-ocaml-dev (>= 1.8),
- libopam-file-format-ocaml-dev,
+ libopam-file-format-ocaml-dev (>= 2.1.2-2~),
  curl
 Build-Depends-Indep:
  texlive-latex-base,
@@ -56,7 +55,8 @@
  darcs,
  mercurial,
  m4,
- rsync
+ rsync,
+ ca-certificates
 Description: package manager for OCaml
  OPAM stands for OCaml PAckage Manager. It aims to suit to a vast number
  of users and use cases, and has unique features:
@@ -80,6 +80,7 @@
 
 Package: opam-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends:
  ${ocaml:Depends},
@@ -112,9 +113,9 @@
 
 Package: opam-installer
 Architecture: any
-Breaks: opam (<< 2.0.0-1),
+Breaks: opam (<< 2.0.7-2),
         opam-docs (<< 2.0.0-1)
-Replaces: opam (<< 2.0.0-1),
+Replaces: opam (<< 2.0.7-2),
           opam-docs (<< 2.0.0-1)
 Depends:
  ${ocaml:Depends},

=== debian/rules ===
--- 
+++ 
@@ -27,10 +27,10 @@
 # do nothing
 
 build-arch: .configure_stamp
-	$(MAKE)
+	HOME=/home/user $(MAKE)
 
 build-indep: .configure_stamp
-	$(MAKE) man
+	$(MAKE) man-html
 
 .PHONY: override_dh_auto_test
 override_dh_auto_test:

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((rc|beta|alpha)[\d.]*)$/$1~$2/,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/opam-$1\.tar\.gz/ \
  https://github.com/ocaml/opam/releases .*/archive/v?(\d\S+)\.tar\.gz

## opam 2.1.2

=== Makefile ===
ifeq ($(findstring clean,$(MAKECMDGOALS)),)
-include Makefile.config
endif

all: opam opam-installer
	@

admin:
	$(DUNE) build $(DUNE_PROFILE_ARG) --root . $(DUNE_ARGS) opam-admin.install

DUNE_PROMOTE_ARG =
DUNE_PROMOTE_ARG += --promote-install-files

ifeq ($(DUNE),)
  DUNE_EXE = src_ext/dune-local/dune.exe
  ifeq ($(shell command -v cygpath 2>/dev/null),)
    DUNE := $(DUNE_EXE)
  else
    DUNE := $(shell echo "$(DUNE_EXE)" | cygpath -f - -a)
  endif
else
  DUNE_EXE=
  # NB make does not export the PATH update in Makefile.config to $(shell ...)
  ifeq ($(shell PATH='$(PATH)' $(DUNE) build --root . --help=plain 2>/dev/null \
                  | grep -F -- '$(DUNE_PROMOTE_ARG) '),)
    DUNE_PROMOTE_ARG =
  endif
endif

OPAMINSTALLER = ./opam-installer$(EXE)

ALWAYS:
	@

DUNE_DEP = $(DUNE_EXE)
JBUILDER_ARGS ?=
DUNE_ARGS ?= $(JBUILDER_ARGS)
DUNE_PROFILE ?= release

ifeq ($(DUNE_PROFILE_ARG),release)
  # TODO Replace with --release when we require dune >= 2.5
  DUNE_PROFILE_ARG = --profile=release
else
  DUNE_PROFILE_ARG = --profile=$(DUNE_PROFILE)
endif

src_ext/dune-local/dune.exe: src_ext/dune-local.stamp $(DUNE_SECONDARY)
ifeq ($(DUNE_SECONDARY),)
	cd src_ext/dune-local && ocaml bootstrap.ml
else
	cd src_ext/dune-local && ( unset OCAMLLIB ; unset CAML_LD_LIBRARY_PATH ; PATH="$(dir $(realpath $(DUNE_SECONDARY))):$$PATH" ../../$(DUNE_SECONDARY) bootstrap.ml )
endif

src_ext/dune-local.stamp:
	$(MAKE) -C src_ext dune-local.stamp

dune: $(DUNE_DEP)
	@$(DUNE) build $(DUNE_PROFILE_ARG) --root . $(DUNE_ARGS) @install

opam: $(DUNE_DEP) build-opam processed-opam.install
	@$(LN_S) -f _build/default/src/client/opamMain.exe $@$(EXE)
ifneq ($(MANIFEST_ARCH),)
	@mkdir -p Opam.Runtime.$(MANIFEST_ARCH)
	@cp -f src/manifest/Opam.Runtime.$(MANIFEST_ARCH).manifest Opam.Runtime.$(MANIFEST_ARCH)/
	@cd Opam.Runtime.$(MANIFEST_ARCH) && $(LN_S) -f ../_build/install/default/bin/Opam.Runtime.$(MANIFEST_ARCH)/libstdc++-6.dll .
	@cd Opam.Runtime.$(MANIFEST_ARCH) && $(LN_S) -f ../_build/install/default/bin/Opam.Runtime.$(MANIFEST_ARCH)/libwinpthread-1.dll .
	@cd Opam.Runtime.$(MANIFEST_ARCH) && $(LN_S) -f ../_build/install/default/bin/Opam.Runtime.$(MANIFEST_ARCH)/$(RUNTIME_GCC_S).dll .
endif

opam-installer: $(DUNE_DEP) build-opam-installer processed-opam-installer.install
	@$(LN_S) -f _build/default/src/tools/opam_installer.exe $@$(EXE)

opam-admin.top: $(DUNE_DEP)
	$(DUNE) build $(DUNE_PROFILE_ARG) --root . $(DUNE_ARGS) src/tools/opam_admin_topstart.bc
	$(LN_S) -f _build/default/src/tools/opam_admin_topstart.bc $@$(EXE)

lib-ext:
	$(MAKE) -j -C src_ext lib-ext

lib-pkg:
	$(MAKE) -j -C src_ext lib-pkg

download-ext:
	$(MAKE) -C src_ext cache-archives

download-pkg:
	$(MAKE) -C src_ext archives-pkg

clean-ext:
	$(MAKE) -C src_ext distclean

clean:
	$(MAKE) -C doc $@
	rm -f *.install *.env *.err *.info *.out opam$(EXE) opam-admin.top$(EXE) opam-installer$(EXE)
	rm -rf _build Opam.Runtime.*

distclean: clean clean-ext
	rm -rf autom4te.cache bootstrap
	rm -f Makefile.config config.log config.status aclocal.m4
	rm -f src/*.META src/*/.merlin src/manifest/dune src/manifest/install.inc src/stubs/libacl/dune src/stubs/win32/dune src/stubs/win32/cc64 src/ocaml-flags-configure.sexp src/stubs/libacl/c-libraries.sexp
	rm -f src/client/linking.sexp src/stubs/c-flags.sexp src/core/developer src/core/version

OPAMINSTALLER_FLAGS = --prefix "$(DESTDIR)$(prefix)"
OPAMINSTALLER_FLAGS += --mandir "$(DESTDIR)$(mandir)"

# With ocamlfind, prefer to install to the standard directory rather
# than $(prefix) if there are no overrides
ifdef OCAMLFIND
ifndef DESTDIR
ifneq ($(OCAMLFIND),no)
    LIBINSTALL_DIR ?= $(shell PATH="$(PATH)" $(OCAMLFIND) printconf destdir)
endif
endif
endif

ifneq ($(LIBINSTALL_DIR),)
    OPAMINSTALLER_FLAGS += --libdir "$(LIBINSTALL_DIR)" --docdir "$(LIBINSTALL_DIR)/../doc"
endif

opam-devel.install: $(DUNE_DEP)
	$(DUNE) build $(DUNE_ARGS) -p opam opam.install
	sed -e "/lib\/opam\/opam/d" -e "s/bin:/libexec:/" opam.install > $@

opam-%.install: $(DUNE_DEP)
	$(DUNE) build $(DUNE_ARGS) -p opam-$* $@

.PHONY: build-opam-installer
build-opam-installer: $(DUNE_DEP) 
	$(DUNE) build $(DUNE_PROFILE_ARG) --root . $(DUNE_ARGS) $(DUNE_PROMOTE_ARG) -- opam-installer.install
opam-installer.install: $(DUNE_DEP)
	$(DUNE) build $(DUNE_PROFILE_ARG) --root . $(DUNE_ARGS) $(DUNE_PROMOTE_ARG) -- opam-installer.install

.PHONY: build-opam
build-opam: $(DUNE_DEP)
	$(DUNE) build $(DUNE_PROFILE_ARG) --root . $(DUNE_ARGS) $(DUNE_PROMOTE_ARG) -- opam-installer.install opam.install
opam.install: $(DUNE_DEP)
	$(DUNE) build $(DUNE_PROFILE_ARG) --root . $(DUNE_ARGS) $(DUNE_PROMOTE_ARG) -- opam-installer.install opam.install

OPAMLIBS = core format solver repository state client

opam-%: $(DUNE_DEP)
	$(DUNE) build $(DUNE_PROFILE_ARG) --root . $(DUNE_ARGS) $(DUNE_PROMOTE_ARG) -- opam-$*.install

opam-lib: $(DUNE_DEP)
	$(DUNE) build $(DUNE_PROFILE_ARG) --root . $(DUNE_ARGS) $(DUNE_PROMOTE_ARG) -- $(patsubst %,opam-%.install,$(OPAMLIBS))

installlib-%: opam-installer opam-%.install
	$(if $(wildcard src_ext/lib/*),\
	  $(error Installing the opam libraries is incompatible with embedding \
	          the dependencies. Run 'make clean-ext' and try again))
	$(OPAMINSTALLER) $(OPAMINSTALLER_FLAGS) opam-$*.install

uninstalllib-%: opam-installer opam-%.install
	$(OPAMINSTALLER) -u $(OPAMINSTALLER_FLAGS) opam-$*.install

libinstall: $(DUNE_DEP) opam-admin.top $(OPAMLIBS:%=installlib-%)
	@

custom-libinstall: $(DUNE_DEP) opam-lib opam
	for p in $(OPAMLIBS); do \
	  ./opam$(EXE) custom-install --no-recompilations opam-$$p.$(version) -- \
	    $(DUNE) install --root . opam-$$p; \
	done

processed-%.install: %.install
	sed -f process.sed $^ > $@

install: processed-opam.install processed-opam-installer.install
	$(OPAMINSTALLER) $(OPAMINSTALLER_FLAGS) processed-opam.install
	$(OPAMINSTALLER) $(OPAMINSTALLER_FLAGS) processed-opam-installer.install

libuninstall: $(OPAMLIBS:%=uninstalllib-%)
	@

uninstall: opam.install
	$(OPAMINSTALLER) -u $(OPAMINSTALLER_FLAGS) $<
	$(OPAMINSTALLER) -u $(OPAMINSTALLER_FLAGS) opam-installer.install

.PHONY: tests
tests: $(DUNE_DEP) src/client/no-git-version
	@$(DUNE) runtest $(DUNE_PROFILE_ARG) --root . $(DUNE_ARGS) src/ tests/ --no-buffer; \
	ret=$$?; \
	echo "###     TESTS RESULT SUMMARY     ###"; \
	for t in _build/default/tests/reftests/*.test; do \
	  printf "%-30s" $$(basename $$t .test); \
	  if diff -q --strip-trailing-cr $$t $${t%.test}.out >/dev/null; \
	  then printf '\033[32m[ OK ]\033[m\n'; \
	  else printf '\033[31m[FAIL]\033[m\n'; \
	  fi; \
	done; \
	test $$ret -eq 0

.PHONY: crowbar
# only run the quickcheck-style tests, not very covering
crowbar: $(DUNE_DEP)
	$(DUNE) exec --root . -- src/crowbar/test.exe

.PHONY: crowbar-afl
# runs the real AFL deal, but needs to be done in a +afl switch
crowbar-afl: $(DUNE_DEP)
	$(DUNE) build --root . -- src/crowbar/test.exe
	mkdir -p /tmp/opam-crowbar-input -p /tmp/opam-crowbar-output
	echo foo > /tmp/opam-crowbar-input/foo
	afl-fuzz -i /tmp/opam-crowbar-input -o /tmp/opam-crowbar-output dune exec src/crowbar/test.exe @@

INTERMEDIATE: src/client/no-git-version
src/client/no-git-version:
	touch src/client/no-git-version

# tests-local, tests-git
tests-%: $(DUNE_DEP) src/client/no-git-version
	$(DUNE) build $(DUNE_ARGS) $(DUNE_PROFILE_ARG) --root . @reftest-legacy-$* --force

reftest-gen: src/client/no-git-version
	echo >tests/reftests/dune.inc
	$(DUNE) build $(DUNE_ARGS) $(DUNE_PROFILE_ARG) --root . @reftest-gen --auto-promote --force

reftest-runner: $(DUNE_DEP) src/client/no-git-version
	$(DUNE) build $(DUNE_ARGS) $(DUNE_PROFILE_ARG) --root . tests/reftests/run.exe

reftests: $(DUNE_DEP) src/client/no-git-version
	$(DUNE) build $(DUNE_ARGS) $(DUNE_PROFILE_ARG) --root . @reftest

reftest-%: $(DUNE_DEP) src/client/no-git-version
	$(DUNE) build $(DUNE_ARGS) $(DUNE_PROFILE_ARG) --root . @reftest-$* --force

reftests-meld:
	meld `for t in tests/reftests/*.test; do echo --diff $$t _build/default/$${t%.test}.out; done`

.PHONY: doc
doc: all
	$(MAKE) -C doc

.PHONY: man-html
man-html: opam opam-installer
	$(MAKE) -C doc $@

configure: configure.ac m4/*.m4
	aclocal -I m4
	autoconf

release-%:
	$(MAKE) -C release TAG="$*"

ifeq ($(OCAML_PORT),)
ifneq ($(COMSPEC),)
ifeq ($(shell which gcc 2>/dev/null),)
OCAML_PORT=auto
endif
endif
endif

.PHONY: compiler cold
compiler:
	env MAKE=$(MAKE) BOOTSTRAP_EXTRA_OPTS= BOOTSTRAP_OPT_TARGET=opt.opt BOOTSTRAP_ROOT=.. BOOTSTRAP_DIR=bootstrap ./shell/bootstrap-ocaml.sh $(OCAML_PORT)

src_ext/secondary/ocaml/bin/ocaml:
	env MAKE=$(MAKE) BOOTSTRAP_EXTRA_OPTS="--disable-ocamldoc --disable-debug-runtime --disable-debugger" BOOTSTRAP_OPT_TARGET=opt BOOTSTRAP_ROOT=../.. BOOTSTRAP_DIR=src_ext/secondary ./shell/bootstrap-ocaml.sh $(OCAML_PORT)

cold: compiler
	env PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" CAML_LD_LIBRARY_PATH= ./configure --enable-cold-check $(CONFIGURE_ARGS)
	env PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" CAML_LD_LIBRARY_PATH= $(MAKE) lib-ext
	env PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" CAML_LD_LIBRARY_PATH= $(MAKE)

cold-%:
	env PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" CAML_LD_LIBRARY_PATH= $(MAKE) $*

.PHONY: run-appveyor-test
run-appveyor-test:
	env PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" ./appveyor_test.sh

=== doc/Makefile ===
-include ../Makefile.config

ifeq ($(DUNE),)
  DUNE_EXE = ../src_ext/dune-local/_boot/install/default/bin/dune$(EXE)
  ifeq ($(shell command -v cygpath 2>/dev/null),)
    DUNE := $(DUNE_EXE)
  else
    DUNE := $(shell echo "$(DUNE_EXE)" | cygpath -f - -a)
  endif
else
  DUNE_EXE=
endif

DUNE_PROFILE ?= release
DUNE_ARGS ?= 

ifeq ($(DUNE_PROFILE_ARG),release)
  # TODO Replace with --release when we require dune >= 2.5
  DUNE_PROFILE_ARG = --profile=release
else
  DUNE_PROFILE_ARG = --profile=$(DUNE_PROFILE)
endif

.PHONY: man html pages
all: html pages

MANDIR = ../_build/default/doc/man

.PHONY: man-html
man-html:
	rm -rf man-html
	mkdir -p $@
	echo '<!DOCTYPE html>' >$@/index.html
	echo '<html><head>' >>$@/index.html
	echo '  <title>Opam man-pages index</title>' >>$@/index.html
	echo '</head><body>' >>$@/index.html
	echo '<h1>Opam $(version) man-pages index</h1>' >>$@/index.html
	echo '<ul>' >>$@/index.html
	for f in ${MANDIR}/*; do\
	  man2html -r $$f | sed 1,2d > $@/$$(basename $$f .1).html;\
	  echo "  <li><a href=\"$$(basename $$f .1).html\">$$(basename $$f .1)</a></li>" >>$@/index.html;\
	done
	echo '</ul>' >>$@/index.html
	echo '</body></html>' >>$@/index.html

html:
	rm -rf html
	cd .. && $(DUNE) build $(DUNE_PROFILE_ARG) --root . $(DUNE_ARGS) @doc
	cp -r ../_build/default/_doc/_html html
	sed 's/%{OPAMVERSION}%/'$(version)'/g' index.html > html/index.html
# Not to break older links, add manpages to the `ocamldoc` dir
	mkdir -p html/ocamldoc
	cd html/ocamldoc && for f in ../*/*/index.html; do\
	  ln -sf $$f $$(basename $$(dirname $$f)).html;\
	done

pages/%.html: pages/%.md
	omd $^ -o $@

PAGES=$(wildcard pages/*.md)

pages: $(PAGES:.md=.html)

clean:
	rm -rf dependencies.dot html/ocamldoc man-html pages/*.html html/index.html

=== release/Makefile ===
--- 
+++ 
@@ -8,11 +8,11 @@
 TARGETS = x86_64-linux i686-linux armhf-linux arm64-linux
 # todo: x86_64-darwin
 
-OCAMLV = 4.04.2
+OCAMLV = 4.10.2
 # currently hardcoded in Dockerfile.in
 OCAML_URL = https://caml.inria.fr/pub/distrib/ocaml-$(basename $(OCAMLV))/ocaml-$(OCAMLV).tar.gz
 
-HOST_OS = $(shell uname -s | tr A-Z a-z)
+HOST_OS = $(shell uname -s | tr A-Z a-z | sed 's/darwin/macos/')
 HOST = $(shell uname -m | sed 's/amd64/x86_64/')-$(HOST_OS)
 
 all: $(patsubst %,out/opam-$(VERSION)-%,$(TARGETS))
@@ -21,7 +21,7 @@
 	mkdir -p out
 	cd out && curl -OfL $(FULL_ARCHIVE_URL) || { \
 	  git clone $(GIT_URL) -b $(TAG) --depth 1 opam-full-$(VERSION); \
-	  sed 's/^AC_INIT(opam,.*)/AC_INIT(opam,$(OPAM_VERSION))/' > \
+	  sed 's/^AC_INIT(opam,.*)/AC_INIT(opam,$(OPAM_VERSION))/' opam-full-$(VERSION)/configure.ac > \
 	    opam-full-$(VERSION)/configure.ac.tmp; \
 	  mv opam-full-$(VERSION)/configure.ac.tmp \
 	    opam-full-$(VERSION)/configure.ac; \
@@ -37,7 +37,7 @@
 build/Dockerfile.armhf-linux: Dockerfile.in
 	mkdir -p build && sed 's/%TARGET_TAG%/armhf-jessie/g' $^ | sed 's/%CONF%//g' >$@
 build/Dockerfile.arm64-linux: Dockerfile.in
-	mkdir -p build && sed 's/%TARGET_TAG%/arm64-jessie/g' $^ | sed 's/%CONF%//g' >$@
+	mkdir -p build && sed 's/%TARGET_TAG%/arm64-stretch/g' $^ | sed 's/%CONF%//g' >$@
 
 
 build/%.image: build/Dockerfile.%
@@ -47,16 +47,16 @@
 # Actually, this is for debian 8 jessie, and varies wildly
 CLINKING_linux = \
 -Wl,-Bstatic \
--lunix -lbigarray -lmccs_stubs -lmccs_glpk_stubs \
+-lunix -lmccs_stubs -lmccs_glpk_stubs \
 -lstdc++ \
 -Wl,-Bdynamic \
 -static-libgcc
 
-CLINKING_darwin = \
--lunix -lbigarray -lmccs_stubs -lmccs_glpk_stubs \
+CLINKING_macos = \
+-lunix -lmccs_stubs -lmccs_glpk_stubs \
 -lstdc++
 
-CLINKING_openbsd = $(CLINKING_darwin)
+CLINKING_openbsd = $(CLINKING_macos)
 
 LINKING = (-noautolink $(patsubst %,-cclib %,$(CLINKING_$(1))))

=== debian/changelog ===
opam (2.1.2-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Mon, 14 Feb 2022 15:58:35 +0100

opam (2.0.10-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * New upstream release
  * Bump Standards-Version to 4.6.0
  * Bump debhelper compat level to 13
  * Update debian/watch

  [ Alexander Volkov ]
  * Do not build opam-doc when nodoc profile is enabled
  * Move opam-doc from Depends to Suggests

 -- Stéphane Glondu <glondu@debian.org>  Wed, 01 Dec 2021 16:59:38 +0100

=== debian/control ===
--- 
+++ 
@@ -6,15 +6,15 @@
  Mehdi Dogguy <mehdi@debian.org>,
  Nicolas Braud-Santoni <nicoo@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
- ocaml-nox (>= 4.3.0~),
+ debhelper-compat (= 13),
+ ocaml,
  ocamlbuild,
  cppo (>= 1.6.0),
  ocaml-findlib (>= 1.2.4),
  dh-ocaml (>= 0.9),
- dune,
+ ocaml-dune,
  libcudf-ocaml-dev,
- libdose3-ocaml-dev (>= 6.0.1~),
+ libdose3-ocaml-dev (>= 7),
  libre-ocaml-dev (>= 1.7.2~),
  libcmdliner-ocaml-dev (>= 1.0.2~),
  libextlib-ocaml-dev,
@@ -23,14 +23,14 @@
  libopam-file-format-ocaml-dev (>= 2.1.2-2~),
  curl
 Build-Depends-Indep:
- texlive-latex-base,
- texlive-lang-french,
- texlive-latex-extra,
- texlive-latex-recommended,
- texlive-fonts-recommended,
- pandoc,
- latex-make
-Standards-Version: 4.4.0
+ texlive-latex-base <!nodoc>,
+ texlive-lang-french <!nodoc>,
+ texlive-latex-extra <!nodoc>,
+ texlive-latex-recommended <!nodoc>,
+ texlive-fonts-recommended <!nodoc>,
+ man2html-base <!nodoc>,
+ latex-make <!nodoc>
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://opam.ocaml.org
 Vcs-Git: https://salsa.debian.org/ocaml-team/opam.git
@@ -43,7 +43,6 @@
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends},
- opam-doc (= ${source:Version}),
  build-essential,
  opam-installer,
  bubblewrap [linux-any],
@@ -57,6 +56,7 @@
  m4,
  rsync,
  ca-certificates
+Suggests: opam-doc (= ${source:Version}),
 Description: package manager for OCaml
  OPAM stands for OCaml PAckage Manager. It aims to suit to a vast number
  of users and use cases, and has unique features:
@@ -79,6 +79,7 @@
     repository, with minimal effort.
 
 Package: opam-doc
+Build-Profiles: <!nodoc>
 Architecture: all
 Multi-Arch: foreign
 Section: doc

=== debian/tests/control ===
Tests: 4.08.1 ocaml-system
Depends: @, ca-certificates
Restrictions: isolation-container, allow-stderr
# Container (or greater) isolation seems required for bwrap to work correctly

Tests: ocaml-system
Depends: ocaml-nox

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((rc|beta|alpha)[\d.]*)$/$1~$2/,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/opam-$1\.tar\.gz/ \
  https://github.com/ocaml/opam/releases .*/v?([0-9.]+)\.tar\.gz

## opam 2.1.5

=== Makefile ===
--- 
+++ 
@@ -183,7 +183,9 @@
 	echo "###     TESTS RESULT SUMMARY     ###"; \
 	for t in _build/default/tests/reftests/*.test; do \
 	  printf "%-30s" $$(basename $$t .test); \
-	  if diff -q --strip-trailing-cr $$t $${t%.test}.out >/dev/null; \
+	  if [ ! -e $${t%.test}.out ]; \
+	  then printf '\033[33m[SKIP]\033[m\n'; \
+	  elif diff -q --strip-trailing-cr $$t $${t%.test}.out >/dev/null; \
 	  then printf '\033[32m[ OK ]\033[m\n'; \
 	  else printf '\033[31m[FAIL]\033[m\n'; \
 	  fi; \
@@ -225,7 +227,11 @@
 	$(DUNE) build $(DUNE_ARGS) $(DUNE_PROFILE_ARG) --root . @reftest-$* --force
 
 reftests-meld:
-	meld `for t in tests/reftests/*.test; do echo --diff $$t _build/default/$${t%.test}.out; done`
+	meld `for t in tests/reftests/*.test; do \
+	  out=_build/default/$${t%.test}.out; \
+	  if test -f $$out && ! diff -q $$t $$out 2> /dev/null > /dev/null; then \
+	    echo --diff $$t $$out; \
+	  fi; done`
 
 .PHONY: doc
 doc: all
@@ -252,10 +258,10 @@
 
 .PHONY: compiler cold
 compiler:
-	env MAKE=$(MAKE) BOOTSTRAP_EXTRA_OPTS= BOOTSTRAP_OPT_TARGET=opt.opt BOOTSTRAP_ROOT=.. BOOTSTRAP_DIR=bootstrap ./shell/bootstrap-ocaml.sh $(OCAML_PORT)
+	env MAKE=$(MAKE) BOOTSTRAP_EXTRA_OPTS= BOOTSTRAP_TARGETS=world.opt BOOTSTRAP_ROOT=.. BOOTSTRAP_DIR=bootstrap ./shell/bootstrap-ocaml.sh $(OCAML_PORT)
 
 src_ext/secondary/ocaml/bin/ocaml:
-	env MAKE=$(MAKE) BOOTSTRAP_EXTRA_OPTS="--disable-ocamldoc --disable-debug-runtime --disable-debugger" BOOTSTRAP_OPT_TARGET=opt BOOTSTRAP_ROOT=../.. BOOTSTRAP_DIR=src_ext/secondary ./shell/bootstrap-ocaml.sh $(OCAML_PORT)
+	env MAKE=$(MAKE) BOOTSTRAP_EXTRA_OPTS="--disable-ocamldoc --disable-debug-runtime --disable-debugger" BOOTSTRAP_TARGETS="world opt" BOOTSTRAP_ROOT=../.. BOOTSTRAP_DIR=src_ext/secondary ./shell/bootstrap-ocaml.sh $(OCAML_PORT)
 
 cold: compiler
 	env PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" CAML_LD_LIBRARY_PATH= ./configure --enable-cold-check $(CONFIGURE_ARGS)
@@ -267,4 +273,4 @@
 
 .PHONY: run-appveyor-test
 run-appveyor-test:
-	env PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" ./appveyor_test.sh
+	env -u OCAMLLIB -u CAML_LD_LIBRARY_PATH PATH="`pwd`/bootstrap/ocaml/bin:$$PATH" ./appveyor_test.sh

=== doc/Makefile ===
--- 
+++ 
@@ -47,6 +47,7 @@
 	rm -rf html
 	cd .. && $(DUNE) build $(DUNE_PROFILE_ARG) --root . $(DUNE_ARGS) @doc
 	cp -r ../_build/default/_doc/_html html
+	chmod -R +w html
 	sed 's/%{OPAMVERSION}%/'$(version)'/g' index.html > html/index.html
 # Not to break older links, add manpages to the `ocamldoc` dir
 	mkdir -p html/ocamldoc

=== debian/changelog ===
opam (2.1.5-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Bump Standards-Version to 4.6.2
  * Fix debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Sat, 02 Sep 2023 07:35:29 +0200

=== debian/control ===
--- 
+++ 
@@ -30,12 +30,11 @@
  texlive-fonts-recommended <!nodoc>,
  man2html-base <!nodoc>,
  latex-make <!nodoc>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://opam.ocaml.org
 Vcs-Git: https://salsa.debian.org/ocaml-team/opam.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/opam
-Testsuite: autopkgtest
 
 Package: opam
 Architecture: any

## opam 2.1.6

=== debian/changelog ===
opam (2.1.6-1) unstable; urgency=medium

  [ Bo YU ]
  * Team upload.
  * Add 0003-opam-dune-3.11.patch to fix ftbfs issue. (Closes: #1054822)
  * New upstream version 2.1.6
  * Rebase debian/patches
  * Set std-ver to 4.7.0

  [ Gianfranco Costamagna ]
  * Try to fix appveyor bits
  * Add appveyor_build.cmd to debian/clean

 -- Bo YU <tsu.yubo@gmail.com>  Sat, 01 Jun 2024 15:32:52 +0800

=== debian/control ===
--- 
+++ 
@@ -30,7 +30,7 @@
  texlive-fonts-recommended <!nodoc>,
  man2html-base <!nodoc>,
  latex-make <!nodoc>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://opam.ocaml.org
 Vcs-Git: https://salsa.debian.org/ocaml-team/opam.git

## opam 2.2.1

=== debian/changelog ===
opam (2.2.1-1) unstable; urgency=medium

  * New upstream release
  * Add myself to Uploaders

 -- Stéphane Glondu <glondu@debian.org>  Sun, 25 Aug 2024 06:50:32 +0200

opam (2.2.0-4) unstable; urgency=medium

  * Test 4.14.1 switch in autopkgtest

 -- Stéphane Glondu <glondu@debian.org>  Thu, 22 Aug 2024 05:36:44 +0200

opam (2.2.0-3) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload

  [ Kate Deplaix ]
  * Fix autopkgtest

 -- Stéphane Glondu <glondu@debian.org>  Wed, 21 Aug 2024 20:40:08 +0200

opam (2.2.0-2) unstable; urgency=medium

  * Fix autopkgtest

 -- Stéphane Glondu <glondu@debian.org>  Wed, 21 Aug 2024 09:25:30 +0200

opam (2.2.0-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * New upstream release

  [ Kate Deplaix ]
  * Remove 0001-Add-a-test-target.patch as it was ported upstream in
    https://github.com/ocaml/opam/pull/5129
  * Remove 0003-opam-dune-3.11.patch as it was ported upstream in
    https://github.com/ocaml/opam/pull/5870
  * Remove 0002-Use-HOME-env-variable-instead-of.patch as the patch
    does not do anything as mentioned in
    https://github.com/ocaml/opam/issues/5058
  * Remove long unused dependencies

 -- Stéphane Glondu <glondu@debian.org>  Tue, 20 Aug 2024 21:34:28 +0200
